SystemOrganization addCategory: #'Kiwi-Core'!
SystemOrganization addCategory: #'Kiwi-Morphic'!
SystemOrganization addCategory: #'Kiwi-Parser'!
SystemOrganization addCategory: #'Kiwi-Render'!
SystemOrganization addCategory: #'Kiwi-Settings'!
SystemOrganization addCategory: #'Kiwi-Tests'!

!String methodsFor: '*Kiwi' stamp: 'MarianoMontone 6/10/2012 12:39'!
visit: anObject
	anObject acceptString: self! !

PPCompositeParser subclass: #KWGrammar
	instanceVariableNames: 'identifier linkType linkTarget linkDisplay bold italics httpLink link heading4 heading3 heading2 heading1 orderedListItem3 orderedListItem2 orderedListItem1 unorderedListItem3 unorderedListItem2 unorderedListItem1 document nowiki plainText listItemText sectionContent orderedList unorderedList wikiText newline paragraphSeparator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Parser'!

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/14/2012 14:14'!
bold
	^ $* asParser token, 
	   $* asParser token, 
	   plainText, 
	   $* asParser token, 
	   $* asParser token.! !

!KWGrammar methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/15/2012 22:33'!
document
	^(wikiText / heading4 / heading3 / heading2 / heading1 /
	orderedListItem3 / orderedListItem2 / orderedListItem1 /
	unorderedListItem3 / unorderedListItem2 / unorderedListItem1 / 
	paragraphSeparator) star! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 15:26'!
heading1
	^self heading: 1! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 15:26'!
heading2
	^self heading: 2! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 15:26'!
heading3
	^self heading: 3! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 15:26'!
heading4
	^self heading: 4! !

!KWGrammar methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/14/2012 14:26'!
heading: level
	| headingParser |
	headingParser := nil asParser.
	level timesRepeat: [
		headingParser := headingParser, $= asParser token].
	headingParser := headingParser, $= asParser negate plus flatten.
	level timesRepeat: [
		headingParser := headingParser, $= asParser token].
	^headingParser! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/5/2012 19:23'!
httpLink
	^'http://' asParser, (#space asParser / #newline asParser / #cr asParser) negate plus flatten! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/5/2012 20:10'!
identifier
	^(#letter asParser, (#letter asParser / #digit asParser) star) flatten.! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/14/2012 14:28'!
italics
	^$/ asParser token, 
	  $/ asParser token, 
	  $/ asParser negate plus flatten, 
	  $/ asParser token, 
	  $/ asParser token.! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/14/2012 14:29'!
link
	^$[ asParser token, 
	  $[ asParser trim token, 
	  	linkType, 
	  $| asParser trim token, 
		linkTarget, 
	  ($| asParser token, linkDisplay) optional, 
	  $] asParser token, 
        $] asParser token.! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/5/2012 20:10'!
linkDisplay
	^(#word asParser / #space asParser) plus flatten! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 15:11'!
linkTarget
	^identifier! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 15:11'!
linkType
	^identifier! !

!KWGrammar methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/15/2012 23:11'!
listItem: character level: level
	 |p|
       p := #newline asParser, (#space asParser / #tab asParser) star flatten.
       level timesRepeat: [
		p := p, character asParser token].
      p := p,  listItemText.
	^p! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/12/2012 20:25'!
listItemText
	^wikiText! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/14/2012 14:34'!
newline
	^$\ asParser token , $\ asParser token! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/14/2012 15:30'!
nowiki
	^${ asParser token, ${ asParser token, ${ asParser token,
	 (${ asParser / $} asParser) negate plus flatten, 
	$} asParser token, $} asParser token, $} asParser token.! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 23:05'!
orderedList
	^orderedListItem1 plus! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 15:46'!
orderedListItem1
	^self orderedListItem: 1! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 15:46'!
orderedListItem2
	^self orderedListItem: 2 ! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 15:47'!
orderedListItem3
	^self orderedListItem: 3 ! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 15:46'!
orderedListItem: level
	^self listItem: $# level: level
! !

!KWGrammar methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/15/2012 22:41'!
paragraphSeparator
	^#newline asParser, #newline asParser plus! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/15/2012 22:32'!
plainText
	^(bold / italics / httpLink / link /
	heading4 / heading3 / heading2 / heading1 /
	orderedListItem3 / orderedListItem2 / orderedListItem1 /
	unorderedListItem3 / unorderedListItem2 / unorderedListItem1 / 
	newline / nowiki / paragraphSeparator) negate plus flatten! !

!KWGrammar methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 23:03'!
section
	^(heading1 / heading2 / heading3), sectionContent! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/10/2012 12:22'!
sectionContent
	^(wikiText / orderedList / unorderedList) plus! !

!KWGrammar methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 19:04'!
start
	^document! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 23:10'!
unorderedList
	^unorderedListItem1 plus! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 15:45'!
unorderedListItem1
	^self unorderedListItem: 1! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 15:45'!
unorderedListItem2
	^self unorderedListItem: 2! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/4/2012 15:45'!
unorderedListItem3
	^self unorderedListItem: 3! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/15/2012 22:51'!
unorderedListItem: level
	^(self listItem: $* level: level) / (self listItem: $- level: level)
! !

!KWGrammar methodsFor: 'productions' stamp: 'MarianoMontone 6/12/2012 20:57'!
wikiText
	^(bold / italics/ link / httpLink / nowiki / newline / plainText) plus! !

KWGrammar subclass: #KWParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Parser'!

!KWParser methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 18:32'!
bold
	^super bold ==> [:parsed| KWBold new: parsed third]! !

!KWParser methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:07'!
heading1
	^super heading1 ==> [:result | KWHeading new: result third]
	! !

!KWParser methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:27'!
httpLink
	^super httpLink ==> [:parsed| KWHttpLink new: 'http://',  parsed second]! !

!KWParser methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 18:52'!
italics
	^super italics ==> [:parsed| KWItalics new: parsed third]! !

!KWParser methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/10/2012 12:34'!
link
	^super link ==> [:result| 
			(result at:6) isArray ifTrue:[
				KWLink type: result third
						target: (result at: 5) 
						display: (result at:6) second]
			ifFalse:[
				KWLink type: result third
						target: (result at: 5)
						display: nil]]! !

!KWParser methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/12/2012 20:47'!
newline
	^super newline ==> [:parsed| KWNewLine new]! !

!KWParser methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/14/2012 15:29'!
nowiki
	^super nowiki ==> [:parsed| 
		KWNoWiki new: (parsed at: 4)]! !

!KWParser methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/15/2012 23:03'!
orderedListItem1
	^super orderedListItem1 ==> [:result | KWOrderedListItem new: (result at: 4) ]
	! !

!KWParser methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/15/2012 22:37'!
paragraphSeparator
	^super paragraphSeparator ==> [:parsed| KWParagraphSeparator new]! !

!KWParser methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/15/2012 23:04'!
unorderedListItem1
	^super unorderedListItem1 ==> [:result | KWUnorderedListItem new: (result at: 4)]
	! !

!KWParser methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/12/2012 20:33'!
wikiText
	^super wikiText ==> [:parsed|
		KWParagraph new: parsed]! !

StringHolder subclass: #KWWikiHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Morphic'!

!PluggableTextAttribute methodsFor: '*kiwi' stamp: 'MarianoMontone 6/16/2012 12:26'!
actOnClick: anEvent for: target in: aParagraph editor: anEditor
	evalBlock value.
	^ false! !

!Text methodsFor: '*Kiwi' stamp: 'MarianoMontone 6/10/2012 11:59'!
asKWTextMorph
	^ KWTextMorph new contentsAsIs: self! !

PluggableTextMorph subclass: #KWPluggableTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Morphic'!

PPCompositeParserTest subclass: #KWGrammarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Tests'!

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 18:11'!
parserClass
	^KWGrammar! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:02'!
testBold
	self parse: '**bold**' rule: #bold! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:11'!
testHeading1
	self parse: '= My heading =' rule: #heading1! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:12'!
testHeading2
	self parse: '== My heading ==' rule: #heading2! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:14'!
testHeading3
	self parse: '=== My heading ===' rule: #heading3! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:15'!
testHttpLink
	self parse:'http://www.seaside.st' rule: #httpLink! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 18:48'!
testIdentifier
	self parse: 'identifier' rule: #identifier! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:09'!
testItalics
	self parse: '//italics//' rule: #italics! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:23'!
testLink
	self parse:'[[class|Object]]' rule: #link! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:25'!
testLinkWithDisplay
	self parse:'[[class|Object|Object class]]' rule: #link! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/12/2012 20:48'!
testNewline
	self parse: '\\' rule: #newline! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:33'!
testNoWiki
	self parse:'{{{this is not formatted}}}' rule: #nowiki! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:56'!
testOrderedListItem1
	self parse: '# Item' rule: #orderedListItem1! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:56'!
testOrderedListItem2
	self parse: '## Item' rule: #orderedListItem2! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:57'!
testOrderedListItem3
	self parse: '### Item' rule: #orderedListItem3! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:39'!
testUnorderedListItem1
	self parse: '* Item' rule: #unorderedListItem1! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:52'!
testUnorderedListItem2
	self parse: '** Item' rule: #unorderedListItem2! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/4/2012 22:52'!
testUnorderedListItem3
	self parse: '*** Item' rule: #unorderedListItem3! !

!KWGrammarTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 18:07'!
testWikiText
	self parse:'hello **world**' rule: #wikiText
	! !

KWGrammarTest subclass: #KWParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Tests'!

!KWParserTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 18:29'!
parserClass
	^KWParser! !

!KWParserTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 18:33'!
testBold
	super testBold.
	self assert: (result class = KWBold and: [result text = 'bold'])! !

!KWParserTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:02'!
testHeading1
	super testHeading1.
	self assert: (result class = KWHeading and: [result title = 'My heading'])! !

!KWParserTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:00'!
testItalics
	super testItalics.
	self assert: (result class = KWItalics and: [result text = 'italics'])! !

!KWParserTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/12/2012 20:49'!
testNewline
	super testNewline.
	self assert: (result class = KWNewLine)! !

!KWParserTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/11/2012 22:40'!
testOrderedListItem1
	super testOrderedListItem1.
	self assert: (result class = KWOrderedListItem)
	! !

!KWParserTest methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/11/2012 22:40'!
testUnorderedListItem1
	super testUnorderedListItem1.
	self assert: (result class = KWUnorderedListItem)
	! !

Object subclass: #KWBold
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Parser'!

!KWBold class methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 18:16'!
new: aString
	^super new initialize: aString! !

!KWBold methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 18:16'!
initialize: aString
	text := aString! !

!KWBold methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:12'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self text printOn: aStream.
	aStream nextPut: $)! !

!KWBold methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 18:16'!
text

	^ text! !

!KWBold methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 18:16'!
text: anObject

	text := anObject! !

!KWBold methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/10/2012 12:36'!
visit: anObject
	anObject acceptKWBold: self! !

Object subclass: #KWHeading
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Parser'!

!KWHeading class methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 18:58'!
new: aString
	^super new initialize: aString! !

!KWHeading methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:08'!
initialize: aString
	title := aString trimBoth! !

!KWHeading methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:12'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self title printOn: aStream.
	aStream nextPut: $)! !

!KWHeading methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 19:01'!
title

	^ title! !

!KWHeading methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 19:01'!
title: anObject

	title := anObject! !

!KWHeading methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/10/2012 12:37'!
visit: anObject
	anObject acceptKWHeading: self! !

Object subclass: #KWHttpLink
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Parser'!

!KWHttpLink class methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:25'!
new: aString
	^super new initialize: aString! !

!KWHttpLink methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:26'!
initialize: aString
	url := aString! !

!KWHttpLink methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:27'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self url printOn: aStream.
	aStream nextPut: $)! !

!KWHttpLink methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 19:25'!
url

	^ url! !

!KWHttpLink methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 19:25'!
url: anObject

	url := anObject! !

!KWHttpLink methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/10/2012 13:06'!
visit: anObject
	anObject acceptKWHttpLink: self! !

Object subclass: #KWItalics
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Parser'!

!KWItalics class methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 18:46'!
new: aString
	^super new initialize: aString
! !

!KWItalics methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 18:47'!
initialize: aString
	text := aString! !

!KWItalics methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:12'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self text printOn: aStream.
	aStream nextPut: $)! !

!KWItalics methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 18:47'!
text

	^ text! !

!KWItalics methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 18:47'!
text: anObject

	text := anObject! !

!KWItalics methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/10/2012 12:37'!
visit: anObject
	anObject acceptKWItalics: self! !

Object subclass: #KWKiwiSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Settings'!

!KWKiwiSettings class methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/12/2012 11:14'!
defaultColorSettingsOn: aBuilder
	<systemsettings>
	(aBuilder setting: #headingsColor)
		target: self;
		label: 'Headings color' translated;
		description: 'Sets the default color for wiki headings' translated;
		parent: #kiwi.
	(aBuilder setting: #headingsFont)
		target: self;
		label: 'Headings font' translated;
		description: 'Sets the default font for wiki headings' translated;
		parent: #kiwi.
		
		! !

!KWKiwiSettings class methodsFor: 'private' stamp: 'MarianoMontone 6/12/2012 10:43'!
headingsColor
	^KWHeadingsColor ifNil: [KWHeadingsColor := Color brown]! !

!KWKiwiSettings class methodsFor: 'private' stamp: 'MarianoMontone 6/12/2012 10:44'!
headingsColor: aColor 
	KWHeadingsColor := aColor! !

!KWKiwiSettings class methodsFor: 'private' stamp: 'MarianoMontone 6/12/2012 11:04'!
headingsFont
	^KWHeadingsFont ifNil: [KWHeadingsFont :=  StrikeFont familyName: 'NewYork' size: 36]! !

!KWKiwiSettings class methodsFor: 'private' stamp: 'MarianoMontone 6/12/2012 11:05'!
headingsFont: aFont
	KWHeadingsFont := aFont! !

!KWKiwiSettings class methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/12/2012 10:22'!
kiwiSettingsOn: aBuilder
	<systemsettings>
	(aBuilder group: #kiwi)
		label: 'Kiwi'! !

!KWKiwiSettings class methodsFor: 'private' stamp: 'MarianoMontone 6/14/2012 15:24'!
nowikiColor
	^KWNoWikiColor ifNil: [KWNoWikiColor := Color brown]! !

!KWKiwiSettings class methodsFor: 'private' stamp: 'MarianoMontone 6/14/2012 15:25'!
nowikiColor: aColor 
	KWNoWikiColor := aColor! !

!KWKiwiSettings class methodsFor: 'private' stamp: 'MarianoMontone 6/14/2012 15:25'!
nowikiFont
	^KWNoWikiFont ifNil: [KWNoWikiFont :=  StrikeFont familyName: 'NewYork' size: 16]! !

!KWKiwiSettings class methodsFor: 'private' stamp: 'MarianoMontone 6/14/2012 15:25'!
nowikiFont: aFont
	KWNoWikiFont := aFont! !

Object subclass: #KWLink
	instanceVariableNames: 'type target display'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Parser'!

!KWLink class methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 20:15'!
type: typeString target: targetString display: displayString
	^super new initialize: typeString target: targetString display: displayString! !

!KWLink methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 20:16'!
display

	^ display! !

!KWLink methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 20:16'!
display: anObject

	display := anObject! !

!KWLink methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 20:16'!
initialize: typeString target: targetString display: displayString
	self type: typeString.
	self target: targetString.
	self display: displayString
	! !

!KWLink methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 20:30'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self type.
	aStream nextPut: $|.
	aStream nextPutAll: self target.
	aStream nextPut: $|.
	self display printOn: aStream.
	aStream nextPut: $)! !

!KWLink methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 20:16'!
target

	^ target! !

!KWLink methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 20:16'!
target: anObject

	target := anObject! !

!KWLink methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 20:16'!
type

	^ type! !

!KWLink methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 20:16'!
type: anObject

	type := anObject! !

!KWLink methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/10/2012 12:38'!
visit: anObject
	anObject acceptKWLink: self! !

Object subclass: #KWMorphicRenderer
	instanceVariableNames: 'source stream listItemCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Render'!

!KWMorphicRenderer class methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/10/2012 12:03'!
on: source
	^super new initialize: source! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/10/2012 12:48'!
acceptKWBold: aKWBold
	stream withAttribute: TextEmphasis bold
			do: [ stream nextPutAll: aKWBold text]! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/14/2012 15:27'!
acceptKWHeading:heading
	| font |
	font := KWKiwiSettings headingsFont.
	stream withAttribute: (TextFontReference toFont: font)
		do: [
			stream withAttribute: (TextColor color: KWKiwiSettings headingsColor)
				do:[
				 stream nextPutAll: heading title]].
	stream cr; cr.! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/10/2012 13:10'!
acceptKWHttpLink: link
	stream withAttribute: (PluggableTextAttribute evalBlock:[('Open link ' , link url) inspect])
		do:[ stream nextPutAll: link url]! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/10/2012 13:05'!
acceptKWItalics: aKWItalics
	stream withAttribute: TextEmphasis italic
			do: [ stream nextPutAll: aKWItalics text]! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/10/2012 13:06'!
acceptKWLink: link
	stream withAttribute: (PluggableTextAttribute evalBlock: [Smalltalk tools browser fullOnClass: (Compiler evaluate: link target)])
	do:[link display ifNotNil:[
			stream nextPutAll: link display]
		ifNil:[
			stream nextPutAll: link target]]! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/12/2012 20:52'!
acceptKWNewLine: aKWNewLine
	stream cr! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/14/2012 15:28'!
acceptKWNoWiki: nowiki
	| font |
	font := KWKiwiSettings nowikiFont.
	stream withAttribute: (TextFontReference toFont: font)
		do: [
			stream withAttribute: (TextColor color: KWKiwiSettings nowikiColor)
				do:[
				 stream nextPutAll: nowiki content]]! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/15/2012 23:00'!
acceptKWOrderedListItem: listitem 
	| font |
	font := StrikeFont familyName: 'NewYork' size: 20.
	stream
		withAttribute: (TextFontReference toFont: font)
		do: [stream
				withAttribute: (TextColor color: Color brown)
				do: [stream nextPutAll: listItemCount printString.
					stream nextPutAll: '. ']].
	listItemCount := listItemCount + 1.
	self renderContent: listitem content contents.
	stream cr.! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/11/2012 22:56'!
acceptKWParagraph: paragraph
	self renderContent: paragraph contents.
	stream cr; cr.! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/15/2012 22:38'!
acceptKWParagraphSeparator: aKWParagraphSeparator
! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/15/2012 23:01'!
acceptKWUnorderedListItem: listitem 
	| font |
	font := StrikeFont familyName: 'NewYork' size: 20.
	stream
		withAttribute: (TextFontReference toFont: font)
		do: [stream
				withAttribute: (TextColor color: Color brown)
				do: [stream nextPut: $*]].
	stream space.
	self renderContent: listitem content contents.
	stream cr! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/10/2012 12:46'!
acceptString: aString
	stream nextPutAll: aString! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/14/2012 15:35'!
initialize: _source 
	source := _source.
	listItemCount := 1! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/13/2012 19:18'!
render
	stream := TextStream on: (Text new: 400).
	source do: [:each |
		each visit: self].
	^stream contents! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/11/2012 23:02'!
renderContent: content
	content isArray ifTrue: [
		content do:[:each|	
			each visit: self]]
				ifFalse:[
					content visit: self]! !

!KWMorphicRenderer methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/13/2012 19:20'!
wikiWindow
	| labelString window pane |
	labelString := 'Kiwi'.
	window := (SystemWindow labelled: labelString) model: self.
	pane := (KWWikiHolder new contents: self render contents) buildTextMorph.
	window addMorph: pane frame: (0@0 corner: 1@1).
	^window! !

Object subclass: #KWNewLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Parser'!

!KWNewLine methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/12/2012 20:52'!
visit: anObject
	anObject acceptKWNewLine: self! !

Object subclass: #KWNoWiki
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Parser'!

!KWNoWiki class methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 20:00'!
new: anArray
	^super new initialize: anArray
! !

!KWNoWiki methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 20:01'!
content

	^ content! !

!KWNoWiki methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 20:01'!
content: anObject

	content := anObject! !

!KWNoWiki methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 20:01'!
initialize: anArray
	self content: anArray! !

!KWNoWiki methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 20:01'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self content printOn: aStream.
	aStream nextPut: $)! !

!KWNoWiki methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/10/2012 12:38'!
visit: anObject
	anObject acceptKWNoWiki: self! !

Object subclass: #KWOrderedListItem
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Parser'!

!KWOrderedListItem class methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:49'!
new: anArray
	^super new initialize: anArray! !

!KWOrderedListItem methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 19:49'!
content

	^ content! !

!KWOrderedListItem methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 19:49'!
content: anObject

	content := anObject! !

!KWOrderedListItem methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:49'!
initialize: anArray
	self content: anArray! !

!KWOrderedListItem methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:50'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self content printOn: aStream.
	aStream nextPut: $)! !

!KWOrderedListItem methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/11/2012 22:43'!
visit: anObject
	anObject acceptKWOrderedListItem: self! !

Object subclass: #KWParagraph
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Parser'!

!KWParagraph class methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/11/2012 21:13'!
new: contents
	^super new initialize: contents! !

!KWParagraph methodsFor: 'accessing' stamp: 'MarianoMontone 6/11/2012 21:14'!
contents

	^ contents! !

!KWParagraph methodsFor: 'accessing' stamp: 'MarianoMontone 6/11/2012 21:14'!
contents: anObject

	contents := anObject! !

!KWParagraph methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/11/2012 21:14'!
initialize: _contents
	self contents: _contents! !

!KWParagraph methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/11/2012 21:15'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self contents printOn: aStream.
	aStream nextPut: $)! !

!KWParagraph methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/11/2012 21:17'!
visit: anObject
	anObject acceptKWParagraph: self! !

Object subclass: #KWParagraphSeparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Parser'!

!KWParagraphSeparator methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/15/2012 22:36'!
visit: anObject
	anObject acceptKWParagraphSeparator: self! !

Object subclass: #KWSplitEditor
	instanceVariableNames: 'window sourcePane outputPane source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Morphic'!

KWSplitEditor subclass: #KWDebuggingEditor
	instanceVariableNames: 'parsingPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Morphic'!

!KWDebuggingEditor methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/14/2012 00:06'!
initializeWindow
	| parsed |
	parsed := KWParser parse: source.
	
	window := (SystemWindow labelled: 'KWDebuggingEditor') model: KWSplitEditor new.
	sourcePane := PluggableTextMorph on: self text: #source accept: #source:.
	outputPane := (KWWikiHolder new contents: (KWMorphicRenderer on:  parsed) render) buildTextMorph.
	parsingPane := (PluggableTextMorph on: self text:nil accept:nil) editString: parsed printString.
	window addMorph: outputPane frame: (0 @ 0 corner: 1 @ 0.5).
	window addMorph: sourcePane frame: (0 @ 0.5 corner: 1 @ 0.8).
	window addMorph: parsingPane frame: (0 @ 0.8 corner: 1 @ 1)! !

!KWDebuggingEditor methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/15/2012 22:29'!
source: aString
	parsingPane editString: (KWParser parse: aString) printString.
	super source: aString.! !

!KWSplitEditor class methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/13/2012 19:06'!
on: source
	^super new initialize: source! !

!KWSplitEditor methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/13/2012 23:55'!
initialize: _source
	source := _source.
	self initializeWindow
	! !

!KWSplitEditor methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/14/2012 00:05'!
initializeWindow
	window := (SystemWindow labelled: 'KWSplitEditor') model: KWSplitEditor new.
	sourcePane :=(PluggableTextMorph on: self text: #source accept: #source:).
	outputPane := (KWWikiHolder new contents: (KWMorphicRenderer on: (KWParser parse: source)) render) buildTextMorph.
	window addMorph: outputPane frame: (0 @ 0 corner: 1 @ 0.5).
	window addMorph: sourcePane frame: (0 @ 0.5 corner: 1 @ 1)! !

!KWSplitEditor methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/13/2012 19:05'!
openInWorld
	^window openInWorld! !

!KWSplitEditor methodsFor: 'accessing' stamp: 'MarianoMontone 6/13/2012 19:21'!
outputPane

	^ outputPane! !

!KWSplitEditor methodsFor: 'accessing' stamp: 'MarianoMontone 6/13/2012 19:21'!
outputPane: anObject

	outputPane := anObject! !

!KWSplitEditor methodsFor: 'accessing' stamp: 'MarianoMontone 6/13/2012 19:21'!
source

	^ source! !

!KWSplitEditor methodsFor: 'accessing' stamp: 'MarianoMontone 6/13/2012 19:31'!
source: anObject

	source := anObject.
	outputPane setText: (KWMorphicRenderer on: (KWParser parse: anObject)) render! !

!KWSplitEditor methodsFor: 'accessing' stamp: 'MarianoMontone 6/13/2012 19:21'!
sourcePane

	^ sourcePane! !

!KWSplitEditor methodsFor: 'accessing' stamp: 'MarianoMontone 6/13/2012 19:21'!
sourcePane: anObject

	sourcePane := anObject! !

!KWSplitEditor methodsFor: 'accessing' stamp: 'MarianoMontone 6/13/2012 19:21'!
window

	^ window! !

!KWSplitEditor methodsFor: 'accessing' stamp: 'MarianoMontone 6/13/2012 19:21'!
window: anObject

	window := anObject! !

Object subclass: #KWUnorderedListItem
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-Parser'!

!KWUnorderedListItem class methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:55'!
new: anArray
	^super new initialize: anArray! !

!KWUnorderedListItem methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 19:54'!
content

	^ content! !

!KWUnorderedListItem methodsFor: 'accessing' stamp: 'MarianoMontone 6/5/2012 19:54'!
content: anObject

	content := anObject! !

!KWUnorderedListItem methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:54'!
initialize: anArray
	self content: anArray! !

!KWUnorderedListItem methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/5/2012 19:54'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self content printOn: aStream.
	aStream nextPut: $)! !

!KWUnorderedListItem methodsFor: 'as yet unclassified' stamp: 'MarianoMontone 6/11/2012 22:43'!
visit: anObject
	anObject acceptKWUnorderedListItem: self! !
